//
// c-expr.c,  4 Jun 23

#include <ctype.h>
#include <float.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef float expr_type;
#define NEAR_ZERO FLT_MIN

#include "e.h"

#define NUMITER 10000

int zero_cnt=0;


// Random number in range -1..1
// Uniform distribution
expr_type random_m1_p1(void)
{
expr_type d= (expr_type)rand() / (expr_type)RAND_MAX;

return d*2.0-1.0;
}

// Fill v with random values
void mk_rand(void)
{
int i;
for (i=0; i<NUMVARS; i++)
   v[i]=random_m1_p1();
}


void save_results(void)
{
int i,
    zeroes=0;

for (i=0; i<NUMEXPR; i++)
   if (zero_cnt)
      zeroes+=(abs(R[i]) < NEAR_ZERO);
   else
      printf("%e,", R[i]);

if (zero_cnt)
   printf("%d,%d,%d,%d", zeroes, NUMVARS, NUMEXPR, NUMITER);
printf("\n");
}


void write_header(void)
{
int i;
if (zero_cnt)
   printf("zeroes,NUMVARS,NUMEXPR,NUMITER");
else
   for (i=0; i<NUMEXPR; i++)
      printf("e%d,", i+1);
printf("\n");
}


void main(int argc, char **argv)
{
int iter;

srand(NUMVARS); // set seed

// printf("%s | %s\n", argv[0], argv[1]);
if (argc > 1)
   zero_cnt=(strcmp(argv[1], "z") == 0);

// printf("%f\n", random_m1_p1());

/*
int i;
mk_rand();
for (i=0; i<NUMVARS; i++)
   printf("%d %f\n", i, v[i]);
exit(0);
*/


write_header();
for (iter=0; iter < NUMITER; iter++)
   {
   mk_rand();
   eval_expr();
   save_results();
   }
}

