#
# expr-fishing.R, 4 Jun 23

library("colorspace")
library("plyr")


par(bty="l")
par(las=1)
par(pch="+")
pal_col=rainbow(3)


plot_distrib=function(file_str, col_str)
{
ev=read.csv(file_str)

ev$X=NULL

ev=as.vector(as.matrix(ev))
print(c("sd=", sd(ev)))

points(count(round(abs(ev), digits=3)), col=col_str)
}


plot(1, type="n", log="xy",
	xlim=c(1e-3, 1e1), ylim=c(1, 1e5),
	xlab="Result", ylab="Occurrences")


plot_distrib("ev_0.25.csv", pal_col[1])
plot_distrib("ev_0.50.csv", pal_col[2])
plot_distrib("ev_0.75.csv", pal_col[3])

legend("bottomleft", legend=paste0(c(25, 50, 75), "% addition"),
                        fill=pal_col, border="white", bty="n")

# plot_distrib("ev_50.csv", pal_col[2])
# plot_distrib("ev_100.csv", pal_col[3])
# plot_distrib("ev_200.csv", pal_col[4])


ev=read.csv("ev_0.50.csv")

ev$X=NULL

ev=as.vector(as.matrix(ev))
length(which(is.na(ev)))
length(which(is.nan(ev)))
length(which(ev == 0.0))

# plot(count(cut(abs(ev), breaks=50)), log="y")

ev_cnt=count(round(abs(ev), digits=3))
plot(ev_cnt, log="xy",
	xlab="Result")

ev_0_1=subset(ev_cnt, (x>0) & (x <=1))
ev_mod=glm(log(freq) ~ log(x), data=ev_0_1)
summary(ev_mod)

